//  Данный скетч демонстрирует работу Trema-модуля bluetooth в режиме ведущего (master)
//  Модуль подключён к Arduino MEGA по аппаратной шине UART 1
//  Модуль ищет имена и адреса всех bluetooth устройств в радиусе действия
//  Библиотека написана http://iarduino.ru только для Trema-модулей bluetooth и не будет работать с другими модулями

                                           // Вывод RX1 Arduino (вывод 19) подключается к выводу TX модуля
                                           // Вывод TX1 Arduino (вывод 18) подключается к выводу RX модуля
#include <iarduino_Bluetooth_HC05.h>       // Подключаем библиотеку iarduino_Bluetooth_HC05 для работы с модулем
iarduino_Bluetooth_HC05 hc05(2);           // Создаём объект hc05 указывая любой вывод Arduino. Назначенный вывод подключается к выводу K модуля
int i;                                     // Объявляем переменную для вывода результатов работы функций

void setup(){
//  Инициируем передачу данных по аппаратной шине UART для вывода результата в монитор
    Serial.begin(9600);
//  Инициируем работу с модулем hc05, указывая класс UART через который осуществляется связь
    i=hc05.begin(Serial1);
    Serial.print("begin: "); if(i){Serial.println("Ok");} else {Serial.println("Error");}
}                                        

//  Инициализация модуля hc05.begin(); может занять несколько секунд.
//  В этом примере модуль подключается через аппаратный UART-1, следовательно при инициализации работы с модулем hc05.begin() указывается класс Serial1.
//  Модуль можно подключать к любой шине UART, только нужно правильно указать класс (Serial, Serial1, Serial2, Serial3) или объект программного UART.

void loop (){
//  Выполняем поиск устройств, не дольше 10 секунд:
    i=hc05.find(10);
//  Выводим результаты поиска:
    if(i){
        Serial.print("found "); Serial.print(i); Serial.println(" devices:");
        for(int j=0; j<i; j++){
            Serial.print(j+1); Serial.print(") Name: "); Serial.print(hc05.findName[j]); Serial.print(", Address: "); Serial.print(hc05.findAddr[j]); Serial.println(";");
        }
    }else{
        Serial.println("Device not found.");
    }
//  Ждём 1 секунду
    delay(1000);
}

//  Функция hc05.find(время); возвращает количество найденных устройств, а принимает время в секундах, это таймаут после которого требуется прекратить поиск.
//  Если устройства найдены, то функция затратит еще несколько секунд (свыше таймаута) для их опроса.
//  Все найденные имена устройств сохраняются в массив hc05.findName, а адреса устройств в массив hc05.findAddr
//  Индексы обоих массивов совпадают, это значит что:
//  - имя 1 устройства находится в hc05.findName[0], а его адрес в hc05.findAddr[0]
//  - имя 2 устройства находится в hc05.findName[1], а его адрес в hc05.findAddr[1]
//  и т.д.
//  Данной функцией можно найти не более 5 устройств. Если до таймаута найдены все 5 устройств, то функция выполнится быстрее таймаута.
